【POJ 1195】 Mobile phones (树状数组)

【POJ 1195】 Mobile phones (树状数组)

Mobile phones

Time Limit: 5000MS   Memory Limit: 65536K
Total Submissions: 16761   Accepted: 7713

Description

Suppose that the fourth generation mobile phone base stations in the Tampere area operate as follows. The area is divided into squares. The squares form an S * S matrix with the rows and columns numbered from 0 to S-1. Each square contains a base station. The
number of active mobile phones inside a square can change because a phone is moved from a square to another or a phone is switched on or off. At times, each base station reports the change in the number of active phones to the main base station along with
the row and the column of the matrix.

Write a program, which receives these reports and answers queries about the current total number of active mobile phones in any rectangle-shaped area.

Input

The input is read from standard input as integers and the answers to the queries are written to standard output as integers. The input is encoded as follows. Each input comes on a separate line, and consists of one instruction integer and a number of parameter
integers according to the following table.

The values will always be in range, so there is no need to check them. In particular, if A is negative, it can be assumed that it will not reduce the square value below zero. The indexing starts at 0, e.g. for a table of size 4 * 4, we have 0 <= X <= 3 and
0 <= Y <= 3.

Table size: 1 * 1 <= S * S <= 1024 * 1024

Cell value V at any time: 0 <= V <= 32767

Update amount: -32768 <= A <= 32767

No of instructions in input: 3 <= U <= 60002

Maximum number of phones in the whole table: M= 2^30

Output

Your program should not answer anything to lines with an instruction other than 2. If the instruction is 2, then your program is expected to answer the query by writing the answer as a single line containing a single integer to standard output.

Sample Input

0 4
1 1 2 3
2 0 0 2 2
1 1 1 2
1 1 2 -1
2 1 1 2 3
3

Sample Output

3
4

Source

IOI 2001

二维树状数组 一前光写过一维的 一开始写的是第二维树状数组 第一维暴力。。。跑了四千多。。

后来查了查第一维跟第二维一样 累加Lowbite即可 查询的时候用大矩阵减去上面横向矩阵和左面纵向 这样多减了左上角的小矩阵 再加上即可 速度快了好多

兴起封了个类玩。。

代码如下:

#include <iostream>
#include <cstring>
#include <cstdio>
#include <cstdlib>

using namespace std;

class Trie
{
public:
    Trie()
    {
        memset(tr,0,sizeof(tr));
    }
    void run(int t)
    {
        int a,b,c,d;
        if(!t)
        {
            scanf("%d",&a);
            n = a;
        }
        else if(t == 1)
        {
            scanf("%d %d %d",&a,&b,&c);
            Add(a+1,b+1,c);
        }
        else
        {
            scanf("%d %d %d %d",&a,&b,&c,&d);
            printf("%d\n",Sum(c+1,d+1)+Sum(a,b)-Sum(a,d+1)-Sum(c+1,b));
        }
    }
private:
    int tr[1033][1033],n;
    int Lowbite(int x)
    {
        return x&(-x);
    }
    void Add(int x,int y,int data)
    {
        int i,j;
        for(i = x; i <= n; i += Lowbite(i))
            for(j = y; j <= n; j += Lowbite(j))
                tr[i][j] += data;
    }
    int Sum(int x,int y)
    {
        int ans = 0;
        int i,j;
        for(i = x; i > 0; i -= Lowbite(i))
            for(j = y; j > 0; j -= Lowbite(j))
                ans += tr[i][j];
        return ans;
    }
};

int main()
{
    int t;
    Trie *tr = new Trie();
    while(~scanf("%d",&t) && t != 3)
    {
        tr->run(t);
    }
    return 0;
}
//原
#include <iostream>
#include <cstring>
#include <cstdio>
#include <cstdlib>

using namespace std;

int tr[1033][1033],n;

int Lowbite(int x)
{
    return x&(-x);
}

void Add(int x,int y,int data)
{
    int i,j;
    for(i = x; i <= n; i += Lowbite(i))
        for(j = y; j <= n; j += Lowbite(j))
            tr[i][j] += data;
}

int Sum(int x,int y)
{
    int ans = 0;
    int i,j;
    for(i = x; i > 0; i -= Lowbite(i))
        for(j = y; j > 0; j -= Lowbite(j))
            ans += tr[i][j];
    return ans;
}

int main()
{
    int t,a,b,c,d;
    memset(tr,0,sizeof(tr));
    while(~scanf("%d",&t) && t != 3)
    {
        if(!t)
        {
            scanf("%d",&a);
            n = a;
        }
        else if(t == 1)
        {
            scanf("%d %d %d",&a,&b,&c);
            Add(a+1,b+1,c);
        }
        else
        {
            scanf("%d %d %d %d",&a,&b,&c,&d);
            printf("%d\n",Sum(c+1,d+1)+Sum(a,b)-Sum(a,d+1)-Sum(c+1,b));
        }
    }
    return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

时间: 2024-10-07 05:31:59

【POJ 1195】 Mobile phones (树状数组)的相关文章

poj 1195 二维树状数组 及二维树状数组模板

http://poj.org/problem?id=1195 求矩阵和的时候,下标弄错WA了一次... 求矩形(x1,y1) (x2,y2)的sum |sum=sum(x2,y2)-sum(x1-1,y2)-sum(x2,y1-1)+sum(x1-1,y1-1) 二维树状数组讲解:http://blog.csdn.net/u011026968/article/details/38532117 二维树状数组模板: /*========================================

POJ 1195 二维树状数组

Mobile phones Time Limit: 5000MS   Memory Limit: 65536K Total Submissions: 18489   Accepted: 8558 Description Suppose that the fourth generation mobile phone base stations in the Tampere area operate as follows. The area is divided into squares. The

poj 1195 Mobile phones(二维数组)

#include<stdio.h> #include<string.h> #include<algorithm> using namespace std; int c[1048][1048],n; int lowbit[1048]; void add(int x,int y,int d) { int i,j; for(i=x;i<=n;i+=lowbit[i]) for(j=y;j<=n;j+=lowbit[j]) { c[i][j]+=d; } } int

poj 1195:Mobile phones(二维树状数组,矩阵求和)

Mobile phones Time Limit: 5000MS   Memory Limit: 65536K Total Submissions: 14489   Accepted: 6735 Description Suppose that the fourth generation mobile phone base stations in the Tampere area operate as follows. The area is divided into squares. The

poj 1195:Mobile phones(二维线段树,矩阵求和,经典题)

Mobile phones Time Limit: 5000MS   Memory Limit: 65536K Total Submissions: 14391   Accepted: 6685 Description Suppose that the fourth generation mobile phone base stations in the Tampere area operate as follows. The area is divided into squares. The

hdu 1541/poj 2352:Stars(树状数组,经典题)

Stars Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4052    Accepted Submission(s): 1592 Problem Description Astronomers often examine star maps where stars are represented by points on a plan

POJ 2892 Tunnel Warfare (树状数组+二分)

题目大意: 三个操作 D pos  将pos位置摧毁,让它和周围不相连. Q pos 问和pos 相连的有多少个村庄. R 修复最近摧毁的村庄. 思路分析: 树状数组记录这个区间有多少个1. 如果  [s-e] 有e-s+1个1 的话.那么这个区间是相连的. 这样的话,我们就可以用二分的办法求出与某个位置最大相连的数量. 还有这里二分 while(l<=r) { if(满足) { ans=mid; l=mid+1; } else r=mid-1; } #include <cstdio>

poj 2155 二维树状数组

http://poj.org/problem?id=2155 Matrix Time Limit: 3000MS   Memory Limit: 65536K Total Submissions: 17721   Accepted: 6653 Description Given an N*N matrix A, whose elements are either 0 or 1. A[i, j] means the number in the i-th row and j-th column. I

poj 2309 BST 使用树状数组的lowbit

如果领悟了树状数组中的lowbit,这道题就是极其简单的,最底层都是奇数,用lowbit(x)寻找x的父亲,然后x的父亲-1就是最大数 至于lowbit是如何计算的嘛,寻找x的父亲,其实就是x+2^x的二进制末尾0的个数. #include<iostream> #include<stdio.h> using namespace std; typedef long long ll; ll lowbit(int x){ return x&(-x); } int main(){